	MAC mac_display_title

.display_title:
	;*************************
	;**** vsync - 3 lines ****
	;*************************
	jsr do_vsync

	;***************************
	;**** vblank - 37 lines ****
	;***************************
	;---- set up main display stuff ----
	lda INPT4
	and INPT5			;either player can start the game
	and #%10000000
	bne .noexit
		;bit 7 is CLEAR if fire was pressed
		jmp title_finish
.noexit:

	lda #title_speed
	adc title_timer_l
	sta title_timer_l

	lda title_timer_h
	adc #0
	sta title_timer_h
	bcc .no_attract
		;go into attract mode - just the AI playing
		lda #nmodes
		sta mode
		jmp title_finish
.no_attract:

	jsr random			;advance the seed

	ldx #1
	jsr animate_player
	lda #80-(8*2)+sxoffset
	jsr position_player

	;x=1
	stx VDELP0
	stx VDELP1
	stx CTRLPF

	dex
	jsr animate_player
	lda #80-(8*3)+sxoffset
	jsr position_player

	lda #%00000011
	sta NUSIZ0
	sta NUSIZ1

	lda #title_pic_colu
	sta COLUP0
	sta COLUP1
	lda #title_border_colu
	sta COLUPF


	;--- handle the select button ---
	sta WSYNC

	;x still = 0

	lda SWCHB
	and #%00000010
	bne .select_up
		lda select_switch
		bne .select_done
			lda title_timer_h
			and #%00000111
			sta title_timer_h
			inc mode
			ldx #sound_select
			;any non-zero x-value will work for select_switch
.select_up:
	stx select_switch
.select_done:
	stx sound_request_low

	lda mode
	sec
	sbc #nmodes
	bcc .modeok
		;a=0
		sta mode
.modeok:

	jsr do_sound		;has a wsync/hmove in it


	;---- fill out vblank ----
	brk
	.byte vblank_wait+27
	sty VBLANK


	;************************
	;**** visible screen ****
	;************************
	;--- top border ---
	lda #%00000111
	sta PF1
	lda #%11111111
	sta PF2
	brk
	.byte 4

	;--- empty space ---
	tya
	sta PF2
	lda #%00000100
	sta PF1
	brk
	.byte 5

	;---- main display - 38 lines ----
	ldx #36
	txa
	adc title_timer_h
	and #%00000110
	adc #8
	sta COLUP0
	sta COLUP1

	sta WSYNC
.loop:
	;column 1 starts at 42.1 clocks
	;each column is 2.2 clocks wide....
	;42.1	45.0	47.2	50.1	53.0	55.2

	lda title0,x	;4
	sta GRP0		;3		set column 0	
	lda title1,x	;4
	sta GRP1		;3		set column 1, activate column 2
	lda title2,x	;4
	sta GRP0		;3		set 2, activate 1
	lda title3,x	;4
	ldy title4,x	;4
	sta scratch		;3
	stx scratch+1	;3
	lda title5,x	;4
	ldx scratch		;3 = 42

	;wait for the exact right spot.........

	stx GRP1		;3		set 3, activate 2 - 1 must be finished!
	sty GRP0		;3		set 4, activate 3 - 2 must be finished!
	sta GRP1		;3		set 5, activate 4 - 3 must be finished!
	sta GRP0		;3 = 54	activate 5 - 4 must be finished!

	lax scratch+1	;3
	adc title_timer_h	;3
	and #%00000110	;2
	adc #8			;2
	sta COLUP0		;3
	sta.w COLUP1	;4 = 71

	dex				;2
	bpl .loop		;3 = 76, woohoo!

	;--- clean up some ---
	jsr wipe_grpx
	;inx				;x was -1
	stx VDELP0
	stx VDELP1
	;stx GRP1
	;stx GRP0


	;--- empty space ---
	brk
	.byte 10

	;--- draw "hi" icon ---
	lda #<icon_hi
	jsr do_icon

	;--- set up score ---
	lda #sxoffset+60
	jsr position_player

	sta WSYNC
	sta HMOVE

	lda #>score_gfx
	sta digit0+1
	sta digit2+1
	sta digit4+1

	ldx #%00000011
	stx NUSIZ0

	iny					;y was -1 from do_icon
	inx					;x=4 does the high score
	jsr find_digit_ptrs

	ldx #0
	lda hiscore_h
	and #%10000000
	bne .p1hi
		ldx #p0colu-p1colu
.p1hi:

	;--- display high score ---
	jsr title_score_display

	brk
	.byte vislines-153

	;--- p0's last score ---
	;y=0
	ldx #0
	jsr find_digit_ptrs
	ldx #p0colu-p1colu
	jsr title_score_display

	brk
	.byte 2

	;--- p1's last score ---
	;y=0
	ldx #1
	jsr find_digit_ptrs
	dex
	jsr title_score_display


	;--- set up players ---
	;x, GRP0, GRP1 = 0
	stx NUSIZ0
	stx NUSIZ1

	lda #p0colu
	sta COLUP0
	lda #p1colu
	sta COLUP1

	ldy mode
	lda p1frame
	and #%00000011
	ora mode_title_p1animbase,y
	sta p1frame

	lda mode_title_p0x,y
	jsr position_player
	inx
	lda #sxoffset+80+8
	jsr position_player	

	jsr do_plgfx_ptrs

	sta WSYNC
	sta HMOVE

	;--- empty space ---
	brk
	.byte 9

	;--- draw players ---
	ldy #playerheight-1
.players:
		sta WSYNC
		lda (p0gfxptr),y
		sta GRP0
		lda (p1gfxptr),y
		sta GRP1
		dey
		bpl .players

	;--- draw icon ---
	ldx mode
	lda mode_title_icon,x
	jsr do_icon

	;--- empty space ---
	brk
	.byte 6

	;--- bottom border ---
	lda #%00000111
	sta PF1
	lda #%11111111
	sta PF2
	brk
	.byte 4



	;*****************************
	;**** overscan - 30 lines ****
	;*****************************
	lda #2
	sta VBLANK

	brk
	.byte overscan_wait+28

	jmp .display_title

title_finish:
	ENDM